function Kozos=JeloltHasonlit(Jelolt1,Jelolt2);


%A kt jellt kzs halmazt adja vissza (sorrendben is azonosak kell
%legyenek a szimblumok!). A kimeneti szimblumsorozatot is keretezi
%'XXX'-val az elejn s vgn.
% Csak a leghosszabb kzs szakaszt adja vissza
%
% Mindkt jellt elejn vgn van lezr szimblum '###'
%
%Pl. (n*3-as mtrixokrl van sz):
% Jelolt1=['###';'AA1';'BB2';'CC3';'DD4';'EE5';'FF6';'GG7';'HH8';'###']
% Jelolt2=['###';'DDD';'EEE';'ZZZ';'CC3';'DD4';'EE5';'FF6';'III';'HH8';'###']
% -> Kozos=['###','CC3';'DD4';'EE5';'FF6','###']
%

%levlasztjuk az elejrol s a vgrl az '###' lezr szimblumokat.
Jelolt1=Jelolt1(2:end-1,:);
N1=size(Jelolt1,1);
Jelolt2=Jelolt2(2:end-1,:);
N2=size(Jelolt2,1);

Kozos=[];
NKozos=0;

%Eldntjk, hogy melyik jellt a rvidebb
if N1>=N2
    RovidJelolt=Jelolt2;
    HosszuJelolt=Jelolt1;
    NRovid=N2;
    NHosszu=N1;
    NDiff=N1-N2;
else
    RovidJelolt=Jelolt1;
    HosszuJelolt=Jelolt2;
    NRovid=N1;
    NHosszu=N2;
    NDiff=N2-N1;
end


%Sorban megvizsgljuk a rvidebb jellt elso, elso ketto, elso hrom stb.
%szimblumait, hogy megtallhat-e a hosszabb jelltben, annak brmelyik pozcijban. 
%Majd a msodik, msodik ketto stb. szimblumokat
%
%(lehet, hogy gyorsabb lenne visszafele? - ha NKozos mr
% nagyobb, mint ami mg kijhet - ki lehetne lpni a ciklusbl.
% Bonyolultabb, de ksbb megugorhatjuk.)

%A fenti pldnl, Jelolt1 a rvid, teht 

% 1. eloszr 'AA1'-et keresnk a hossz jelltben (nem tallunk)
% 2. msodszor 'BB2'-t keresnk (nem tall)
% 3.    'CC3'-at (tall -> Kozos='CC3')
% 4.    'DD4'-et (tall, de nem hosszabb - marad 'CC3')
% 5.    'EE5'-t (tall, de nem hosszabb - marad 'CC3')
% 6.    'FF6'
% 7.    'GG7'
% 8.    'HH8'
% 9.     ['AA1';'BB2']-t vizsgl, nem tall
% 10.    ['BB2';'CC3']-t vizsgl s nem tall
% 11.    ['CC3';'DD4']-t vizsgl s tall, hosszabb, mint az eddigi kzs
%                               -> Kozos = ['CC3';'DD4']
% 12.    ['DD4';'EE5']-t vizsgl s megtallja, de nem hosszabb az eddigi
%                           Kozos-nl
% ....... S IGY TOVBB

for kk=1:NRovid    %a rvidjellt aktulisan vizsglt rsz-szimblumsor kezdopozcija
    for NAktRovid=1:NRovid-kk+1    %az aktulis rsz-szimblumsor hossza
        AktRovidJelolt=RovidJelolt(kk:kk+NAktRovid-1,:);
        PozAHosszuban=0;   %a hosszjellt rsz-string kezdopozcija
        HosszubanVizsgalFlag=1;
        while HosszubanVizsgalFlag && (PozAHosszuban<NHosszu-NAktRovid+1)
            PozAHosszuban=PozAHosszuban+1;
%             [HosszuJelolt(ii:ii+NAktRovid-1,:);'XXX';AktRovidJelolt]
            if all(all(HosszuJelolt(PozAHosszuban:PozAHosszuban+NAktRovid-1,:)==AktRovidJelolt,2))
                if NAktRovid>NKozos
                    Kozos=AktRovidJelolt;
                    NKozos=NAktRovid;
                    HosszubanVizsgalFlag=0;  % ilyen NAktRovid (rsz-szimblumsor hossz) mellett
                                             % mr legfeljebb ugyanilyen
                                             % hossz kzset tall,
                                             % hosszabbat nem
                end
            end
        end
    end
end

Kozos=['###';Kozos;'###'];  %bekeretezzk az eredmnyt
    

