function [TomoritettSzimbSor,TomoritettIndex,PeriodikusStrukt,KetperiodusuStrukt,AperiodikusStrukt]=Tomorites1(SzimbSor1,SzimbInd1,AktEpizod,AktEpizodStartIdok);

PeriodikusStrukt=[];
KetperiodusuStrukt=[];
AperiodikusStrukt=[];

% Levesszk az AktEpizod-rl a kezdeti s a vg lezr szimblumokat

AktEpizod=AktEpizod(2:end-1,:);


KPer=0.5;   %ha az sszes peridus ennyiszerese azonos hossz, akkor periodikusknt tmrtnk
KPer2=0.1; %ha az sszes lehetsges duplaperidus ennyiszerese azonos hossz, akkor ktperidusknt (is) tmrtnk
SzimbHossz=3;
Vegjel='@';

N=size(SzimbSor1,1);  % a szimblumsor hossza

%Nem teljesen korrekt, mert nem veszi szre, ha egy szablyos peridusba
%bet egy epizd. Ekkor kt rvid keletkezik. Pl. a peridushossz 288, de
%van benne egy 288,100,188,288 szakasz... Ekkor kt extrt vesz fel, pedig
%1 is elg lenne. 
% Hasonlkppen problematikus, ha kt peridus vltakozik
% KORRELCI S BONYOLULTABB FELDOLGOZS!
NAktSt=length(AktEpizodStartIdok);    %Az epizd startidok szma
PotencPeriodusok=diff(AktEpizodStartIdok);  % az adott epizd elofordulsai kzt eltelt idok (potencilis peridusidok)
NP=length(PotencPeriodusok);        %tulajdonkppen NAktSt-1 lesz mindig
LeggyakPer=mode(PotencPeriodusok);       %Mode, or most frequent value in a sample.
NPot=sum(PotencPeriodusok==LeggyakPer);  %Hnyszor szerepel a leggyakoribb peridushossz
NEpizod=size(AktEpizod,1);               %Hny - nem felttlenl egy karakterbol ll - szimblumbl ll az AktEpizd
AktEpizodVekt=reshape(AktEpizod',1,NEpizod*SzimbHossz);


%% peridikus struktura - esetleg hibkkal

% A struktra felptse:
% az eleje egyrtelm?:
% (mivel az aktulis epizod hossza nem kttt, vgjel kell az egyrtelm? lezrshoz
% [AktulisEpizdKarakterVektor Vegjel LeggyakoribbPeriodusHossz ElsoEpizodStartIdo UtolsoEpizodStartIdo...
%                ......{Epizod1_MegelozoPriodusNemALeggyakoribb HanyHianyzik1 Epizod2_MegelozoPriodusNemALeggyakoribb HanyHianyzik2...} Vegjel]
%
%VISSZALLTS: Elindulni az elso esemnyt?l, mindig megnzni a kvetkez? extrt a sorban,
% a HnyHinyzikbl lehet ltni, hogy meddig megy szablyosan
%
% Plda (EpizodVekt='AAABBBCCCBBBAAA')- teljesen szablyos :
% A Startid?k: [110   398   686     974      1262        1550     1838   2126     2414     2702    2990]
% [AAABBBCCCBBBAAA@     288   110  2990@]
%LeggyakoribbPeridus: 288
%
%Pelda kt hiba van a fenti sorban (kimaradt a 398 s a 686->688)
%
% A Startid?k: [110      688     974      1262        1550     1838   2126     2414     2702    2990]
% [AAABBBCCCBBBAAA@     288     110   2990       688 2        974 0@]
%


if NPot>KPer*NAktSt     %peridikusknt tmrtnk, ha legalbb KPer arnyban azonos a diff a szomszdos startid?k kzt
    %a peridikus ler struktra eleje AktEpizd (karakterlnc), a leggyakoribb peridusid?, az els? esemny ideje    
    PeriodikusStrukt=[AktEpizodVekt,Vegjel,sprintf('%8.0f',LeggyakPer),sprintf('%8.0f',AktEpizodStartIdok(1)),sprintf('%8.0f',AktEpizodStartIdok(end))];
    
    if NPot==NP;    %minden peridus azonos hosszsg
        PeriodikusStrukt=[PeriodikusStrukt,Vegjel];
    else
       for kk=1:NP
            if PotencPeriodusok(kk)~=LeggyakPer
                %a kvetkezo startidoponthoz rjuk be.
                if PotencPeriodusok(kk)<LeggyakPer
                    AktHianyzik=0;
                else
                    AktHianyzik=floor(PotencPeriodusok(kk)/LeggyakPer);
                end
                PeriodikusStrukt=[PeriodikusStrukt,sprintf('%8.0f',AktEpizodStartIdok(kk+1)),sprintf('%8.0f',AktHianyzik)];
            end
        end
        PeriodikusStrukt=[PeriodikusStrukt,Vegjel];
    end

end


%% kt peridus struktra - esetleg hibkkal
% ha vltakozik egy P11 P12 peridus, esetleg hibk lehetnek a sorban
% itt is, akr a sima periodikusnl
% A struktra felptse:
% az eleje egyrtelmu:
% (mivel az aktulis epizod hossza nem kttt, vgjel kell az egyrtelmu lezrshoz
% [AktulisEpizdKarakterVektor Vegjel Differencia1 Differencia2 ElsoEpizodStartIdo UtolsoEpizodStartIdo...
%                ......ElsoEpizodStartIdo HanySzabalyosKoveti_1 {MasodikEpizodStartIdo HanySzabalyosKoveti_2...} Vegjel]
%
%VISSZALLTS: Elindulni az elso esemnytol, mindig megnzni, hogy hny jn szablyosan
%Ha extra van, akkor annl 0 jelzi, hogy nem szablyos 
%
% Plda (EpizodVekt='AAABBBCCCBBBAAA')- teljesen szablyos :
% A Startidok: [100   200   400   500    700      800     1000   1100     1300]
% [AAABBBCCCBBBAAA @  100 200 100 1300 100 4@]
%
% 100-nl indul s 4 szablyos 100-200 ciklus van (100-nl,400-nl,700-nl
% s 1000-nl indul egy-egy szablyos duplaciklus
%
%Plda kt hiba van a fenti sorban (400 helyett 420-nl folytatdik a
%msodik, majd kimarad nhny)
%
% A Startidok: [80   180   380   520    620  820  1100      1800     1900   2100  2200 2400]
% [AAABBBCCCBBBAAA @  100 200   80   2400    80 1     520 1   1100 0      1800   2@]
%


%azt keressk eloszr, hogy minden msodik epizdstartbl kpzett
%klnbsg kzt van-e tipikus

%kigyujtjk az egymsutni 3 esemnybol add klnbsg-prokat
TmpMat=zeros(NAktSt-2,2);
for Ind2=1:NAktSt-2   % (NAktSt-2) a TmpMat sorainak szmval azonos
    %ez mindig az Ind2=1....(NAktSt-2) esemnyhez tartoz sor
    TmpMat(Ind2,1:2)=[AktEpizodStartIdok(Ind2+1)-AktEpizodStartIdok(Ind2),AktEpizodStartIdok(Ind2+2)-AktEpizodStartIdok(Ind2+1)];
end

Ind1=(TmpMat(:,1)~=TmpMat(:,2));  %csak azokra lvnk, ahol nem egyforma a kt peridus
LeggyakPer1=mode(TmpMat(Ind1,1));  % az els? oszlop leggyakoribb rtke
IndPot1=find(TmpMat(:,1)==LeggyakPer1);
LeggyakPer12=mode(TmpMat(IndPot1,2));  % az els? oszlop leggyakoribb rtkhez tartoz leggyakoribb msodik oszlop rtk
Ind1_2=all(TmpMat==(ones(size(TmpMat,1),1)*[LeggyakPer1,LeggyakPer12]),2); % azok a sorok, ahol megegyezik a kt rszperidus

Ind2=(TmpMat(:,1)~=TmpMat(:,2));  %csak azokra lvnk, ahol nem egyforma a kt peridus
%kizrjuk azokat, amelyeket az els? oszlopbl kiindulva megtalltunk
Ind2=(Ind2 & not(Ind1_2));
LeggyakPer2=mode(TmpMat(Ind2,2));  % a msodik oszlop leggyakoribb rtke
IndPot2=find(TmpMat(:,2)==LeggyakPer2);
LeggyakPer21=mode(TmpMat(IndPot2,1));  % az msodik oszlop leggyakoribb rtkhez tartoz leggyakoribb els? oszlop rtk
Ind2_1=all(TmpMat==(ones(size(TmpMat,1),1)*[LeggyakPer21,LeggyakPer2]),2); % azok a sorok, ahol megegyezik a kt rszperidus

if sum(Ind1_2)>sum(Ind2_1)
    Ind=Ind1_2;
    Per1=LeggyakPer1;
    Per2=LeggyakPer12;
    
else
    Ind=Ind2_1;
    Per1=LeggyakPer21;
    Per2=LeggyakPer2;
end

if sum(Ind)>KPer2*NAktSt   % ha legalbb KPer2 arnyban a startid?k kzt
    %a peridikus ler struktra eleje AktEpizd (karakterlnc), a leggyakoribb peridusid?, az els? esemny ideje    
    KetperiodusuStrukt=[AktEpizodVekt,Vegjel,sprintf('%8.0f',Per1),sprintf('%8.0f',Per2),sprintf('%8.0f',AktEpizodStartIdok(1)),sprintf('%8.0f',AktEpizodStartIdok(end))];
    kk1=1;
    while kk1<=NAktSt-2
        if all(TmpMat(kk1,:)==[Per1,Per2])  %ha az adott sorban egy keresett duplaciklus kezd?dik
            TmpSzlo=1;
            KetperiodusuStrukt=[KetperiodusuStrukt, sprintf('%8.0f',AktEpizodStartIdok(kk1))];
            kk1=kk1+2;  %ez 2 esemnyt is ler
            while (kk1<=NAktSt-2) && all(TmpMat(kk1,:)==[Per1,Per2])
                TmpSzlo=TmpSzlo+1;
                kk1=kk1+2;  %ez 2 esemnyt is ler, ha megint szablyos lesz utna,
                        %ha utna szablytalan jn, akkor 3 esemnyt r le
            end
            KetperiodusuStrukt=[KetperiodusuStrukt, sprintf('%8.0f',TmpSzlo)];
            kk1=kk1+1;      %az utols szablyos duplaperidus utols id?pontja is ki van piplva
        else  %ha nem szablyos duplaperidus jn
            KetperiodusuStrukt=[KetperiodusuStrukt, sprintf('%8.0f',AktEpizodStartIdok(kk1)), '       0' ];  %sprintf('%8.0f',TmpSzlo=0)
            kk1=kk1+1;
        end
    end    %while kk1<=NAktSt-2
    KetperiodusuStrukt=[KetperiodusuStrukt,Vegjel];
end





%% aperidikus struktra: mindig megadjuk - egyszeru megcsinlni, br
% ltalban nem hatkony -> ha biztosan nem javt []-t adunk vissza
% csak akkor eredmnyez tmrtst, ha legalbb 9 hossz az Aktulis Epizd
% Vektor (AktEpizodVekt) karakterlnc
NAktEpV=length(AktEpizodVekt);
if NAktEpV>8
    AperiodikusStrukt=blanks(NAktEpV+8*(NP+1)+2);   %hogy ne nojjon a for cikuson belul
                %vgn +2: 2 vgjel, egyik az epizdvektort zrja, msik az
                %egszet
    AperiodikusStrukt(1:NAktEpV+1)=[AktEpizodVekt,Vegjel];
    for kk=1:NP+1
        AperiodikusStrukt(NAktEpV+1+(kk-1)*8:NAktEpV+kk*8)=sprintf('%8.0f',AktEpizodStartIdok(kk));
    end
    AperiodikusStrukt(end)=Vegjel;
end


%% Tmrits


IndAktEpizod=true(size(SzimbSor1,1),1);

for kk=1:length(AktEpizodStartIdok)
    AktInd=find(SzimbInd1==AktEpizodStartIdok(kk));
    IndAktEpizod(AktInd:AktInd+NEpizod-1)=false;
end

TomoritettIndex=IndAktEpizod;
TomoritettSzimbSor=SzimbSor1(TomoritettIndex,:);
TomoritettIndex=SzimbInd1(TomoritettIndex);

